/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2019, 2021, 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test samples of the list comprehension construct
 */

/* run */ define test_1() = {
  exists L : {
   L = [ i : i<5] and output L and empty
 }
}.

/* run */ define test_2() = {
  exists L: {
   L = [ i+1 : i<6] and output L and empty
 }
}.


/* run */ define test_3() = {
  exists L: {
   L = [ itompx(i) : i<16] and output L and empty
 }
}.

/* run */ define test_4() = {
  exists L: {
   L = [ itompx(i) : i<16] + [ itompz(i) : i<16] and output L and empty
 }
}.


/* run */ define test_5() = {
  exists L : {
   L = [ itompz(i)+0z42 : i<6] and output L and empty
 }
}.

/* run */ define test_6() = {
  exists L : {
    set random_seed = 1 and 
   L = [ Random mod 42 : i<6] and output L and empty
  }
 }.

/* run */ define test_7() = {
  exists L : {
   L = [ [j : j<2] : i<6] and output L and empty
 }
}.

/* run */ define test_8() = {
  exists L : {
   L = [ [j : j<i] : i<6] and output L and empty
 }
}.

/* run */ define test_9() = {
  exists L : {
   L = [ [j+i : j<i] : i<6] and output L and empty
 }
}.

