/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2013-2019, 2021, 2023 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/* set debug_level=1. */

/* run */ define test_1() = {
    exists J : {
        existsf I : { len(2) and I<-I+1 and I=4 and 
                   J is I and always (format("I=%d J=%d\n",I,J))
        }
    }
}.

/* run */ define test_2() = {
    existsf I : {
        exists J : { len(4) and I=4 and I:=2 and 
                     J is I+1 and always (format("I=%d J=%d\n",I,J))
        }
    }
}.

/* run */ define test_3() = {
   existsf X :{    
     len(4) and X=0  and
     always (format("X=%d\n",X)) and
     {{skip and X:=X+1};skip;skip;skip} and
     {skip;skip;{skip and X:=X+1};skip}
   }
}.


/* run */ define test_4() = {
    exists I : {
        existsf L : { list(L,3) and stable(struct(L)) and len(3) and
                   I=0 and L=[0,1,2] and L:=[4,5,6] and
                   (skip;skip;(L[1]=9 and skip);L=[7,6,3]) and
                      I defaults 1 and
                      always (output(L[I]) and output(I) and output(L))
        }
    }
}.

/* run */ define test_5() = {
    existsf L : { list(L,3) and stable(struct(L)) and  len(3) and
                 L=[0,1,2] and L:=[4,5,6] and 
                 always (output(prev(L)) and  output(L[0]) and output(L))
    }
}.

/* run */ define test_6() = {
    existsf L : { len(3) and L=2 and L:=3 and 
                 always (output(prev(L)) and   output(L))
    }
}.

/* run */ define test_7() = {
    existsf L : { len(1) and 
                 always (output(L))
    }
}.

/* run */ define test_8() = {
  exists Y0,Y1 : { 
    existsf X : { 
        len(4) and X=0  and always (
            format("X=%d, Prev(X)=%d, Y0=%d, Y1=%d\n",X,prev(X),Y0,Y1)) and
       {{Y0=X and  skip and X:=X+1};
        {Y0=X and skip};
        {Y0=X and skip};
        {Y0=X and skip};
        {Y0=X and empty}} and
       {{Y1=X and skip};
        {Y1=X and skip};
        {Y1=X and skip and X:=X+1};
        {Y1=X and skip};
        {Y1=X and empty}
       }
    }
 }
}.

/* run */ define test_9() = {
  exists J : { 
    existsf I : { 
        len(2) and I<-I+1 and I=4 and 
                   J is I and always (format("I=%d J=%d\n",I,J))
    }
  }
}.

/* run */ define test_10() = 
{
  existsf S: (list(S,1) and stable(struct(S)) and   len(3) and
             S=[1] and fin(S=[2]) and
               always output(S)) 
}.

/* run */ define test_11() = 
{
  existsf S: (len(3) and stable(struct(S)) and  list(S,3) and  
              S=[0,1,2] and S[1]:=2 and
             always output(S))
}.
