# 
#
#
# Copyright (C) 2023 Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

package require Plotchart

#package require NAME VERSION
package provide fuzzy 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
    variable canv;
    
# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
  variable canv;        
  variable s;

  $canv delete all
    
  set lft   [lindex $nl 0];
  set rght  [lindex $nl 1];
  
  set cdom  [list $lft $rght [expr ($rght - $lft)/10]]; 
  
    
#
# Create the plot with its x- and y-axes
#
    set s [::Plotchart::createXYPlot $canv $cdom {0.0 1.01 0.1}];
    $s xticklines "black" "dots1"
    $s yticklines "black" "dots1" 
    $s title "membership function output"

}

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc plot {nl} {

  variable canv;
  variable s;


  foreach {x y} $nl {
    $s plot series1 $x $y
  }

}

}; # end of namespace out

