/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of hedges
 */
 
load "fuzzy_logic".

/* run */ define test_1() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_somewhat(Mu_X) and
   output(Mu_Y) and empty
 }
}.

/* run */ define test_2() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_very(Mu_X) and
   output(Mu_Y) and empty
 }
}.

/* run */ define test_3() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_extremely(Mu_X) and
   output(Mu_Y) and empty
 }
}.

/* run */ define test_4() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_very_very(Mu_X) and
   output(Mu_Y) and empty
 }
}.

/* run */ define test_5() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_h_custom(6)(Mu_X) and
   output(Mu_Y) and empty
 }
}.




