/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of membership functions
 */
 
/******************************************************************/

load "fuzzy_logic".

/* run */ define test_1() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_2() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = triangle_mf($3$,$6$,$8$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_3() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = gaussian_mf($2$,$5$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_4() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = gbell_mf($2$,$4$,$6$) and
   Mu_X = map(mf_X, X) and
   output(Mu,X) and empty
 }
}.

/* run */ define test_5() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = sig_mf($2$,$4$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_6() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = gaussian2_mf($2$,$4$,$1$,$8$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_7() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = linz_mf($4$,$6$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_8() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = lins_mf($4$,$6$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_9() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = dsig_mf($5$,$2$,$5$,$7$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_10() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = psig_mf($2$,$3$,$-5$,$8$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_11() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = z_mf($3$,$7$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_12() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = s_mf($1$,$8$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.

/* run */ define test_13() = {
 exists mf_X,X,Mu_X : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = pi_mf($1$,$4$,$5$,$10$) and
   Mu_X = map(mf_X, X) and
   output(Mu_X) and empty
 }
}.


